#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <windows.h>
#include <mmsystem.h>

/*
To compile this source code you'll need "puff.c" and "puff.h" files from zlib package.
Get this package from official site: http://zlib.net/
Requered files can be found in /contrib/puff/ folder inside archive.
*/

#include "puff.h"

/*
http://msdn.microsoft.com/en-US/library/windows/desktop/bb943991.aspx
http://msdn.microsoft.com/en-us/library/windows/desktop/bb943982.aspx
http://msdn.microsoft.com/en-us/library/windows/desktop/bb943984.aspx
*/

#pragma pack (1)

#define DDS_MAGIC 0x20534444
typedef struct {
  DWORD dwSize;
  DWORD dwFlags;
  DWORD dwFourCC;
  DWORD dwRGBBitCount;
  DWORD dwRBitMask;
  DWORD dwGBitMask;
  DWORD dwBBitMask;
  DWORD dwABitMask;
} DDS_PIXELFORMAT;

typedef struct {
  DWORD           dwMagic;
  DWORD           dwSize;
  DWORD           dwFlags;
  DWORD           dwHeight;
  DWORD           dwWidth;
  DWORD           dwPitchOrLinearSize;
  DWORD           dwDepth;
  DWORD           dwMipMapCount;
  DWORD           dwReserved1[11];
  DDS_PIXELFORMAT ddspf;
  DWORD           dwCaps;
  DWORD           dwCaps2;
  DWORD           dwCaps3;
  DWORD           dwCaps4;
  DWORD           dwReserved2;
} DDS_HEADER;

/*****************************************************/

#define TEX_TEX  0x20584554

typedef struct {
  DWORD dwTEX;
  WORD  dwWidth;
  WORD  dwHeight;
  DWORD dwFlags;
  DWORD dwZero1;
  DWORD dwZero2;
  DWORD dwPackSize;
  DWORD dwUnpkSize;
  DWORD dwName;
} TEX_HEADER;

int main(int argc, char *argv[]) {
FILE *fl;
BYTE *p, *u;
DDS_HEADER dh;
TEX_HEADER th;
  if (argc != 3) {
    printf("Usage: stex2dds filename.tex filename.dds\n");
    return(1);
  }
  fl = fopen(argv[1], "rb");
  fread(&th, 1, sizeof(th), fl);
  if (th.dwTEX != TEX_TEX) {
    printf("ERROR: invalid input file.\n");
    return(2);
  }
  p = (BYTE *) malloc(th.dwPackSize);
  fread(p, 1, th.dwPackSize, fl);
  fclose(fl);

  u = (BYTE *) malloc(th.dwUnpkSize);

  /* unpack deflate buffer */
  puff(u, &th.dwUnpkSize, p, &th.dwPackSize);

  memset(&dh, 0, sizeof(dh));
  dh.dwMagic = DDS_MAGIC;
  dh.dwSize = sizeof(dh) - 4;
  dh.dwWidth = th.dwWidth;
  dh.dwHeight = th.dwHeight;
  dh.dwFlags = 1 | 2 | 4 | 0x1000; /* DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH | DDSD_PIXELFORMAT */
  dh.ddspf.dwSize = sizeof(dh.ddspf);
  dh.ddspf.dwFlags = 4; /* DDPF_FOURCC; */
  dh.ddspf.dwFourCC = MAKEFOURCC('D', 'X', 'T', '5');

  fl = fopen(argv[2], "wb");
  fwrite(&dh, 1, sizeof(dh), fl);
  fwrite(u, 1, th.dwUnpkSize, fl);
  fclose(fl);

  free(u);
  free(p);
  return(0);
}
